/* ------------------------------------------------------------------ */
/*           CONFIGURATION MANAGEMENT OF EDF VERSION                  */
/* MODIF UTTLIM UTILITAI  DATE 07/04/2009   AUTEUR COURTOIS M.COURTOIS */
/* ================================================================== */
/* COPYRIGHT (C) 1991 - 2001  EDF R&D              WWW.CODE-ASTER.ORG */
/*                                                                    */
/* THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR      */
/* MODIFY IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS     */
/* PUBLISHED BY THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE */
/* LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.                    */
/* THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,    */
/* BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF     */
/* MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU   */
/* GENERAL PUBLIC LICENSE FOR MORE DETAILS.                           */
/*                                                                    */
/* YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE  */
/* ALONG WITH THIS PROGRAM; IF NOT, WRITE TO : EDF R&D CODE_ASTER,    */
/*    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.     */
/* ================================================================== */
/* ------------------------------------------------------------------ */
/* temps (sec)  maxi pour ce processus                    	*/
extern char g_tpmax[];

#include <string.h>
#include <stdio.h>

#include <sys/time.h>
//<modif>
//<old>
/*
#include <sys/resource.h>
*/
//</old>
//<new>
#if !defined _IGNORE_RLIMIT
#include <sys/resource.h>
#endif
//</new>
//</modif>
#include <float.h>
#include <limits.h>

#include "aster.h"

void DEFP(UTTLIM, uttlim, DOUBLE *t_lim)
{
   long long itpm;
   DOUBLE tmax;
//<modif>
//<old>
/*
#ifdef _USE_RLIMIT
   struct rlimit rlp;
#endif
*/
//</old>
//<new>
#if !defined _IGNORE_RLIMIT
#ifdef _USE_RLIMIT
   struct rlimit rlp;
#endif
#endif
//</new>
//</modif>
//<modif>
//<old>
/* test sdld102a (STA10.0) fails in bibfor/algorith/mdadap.f (544) overflow
   tmax = ((DOUBLE) LONG_MAX)/2;
   if (strlen(g_tpmax) > 0) {
      sscanf(g_tpmax,"%Ld",&itpm);
      *t_lim = (DOUBLE)itpm;
   }
   else {
*/
//</old>
//<new>
   tmax = ((DOUBLE) LONG_MAX) * 1.0e-4;
   if (strlen(g_tpmax) > 0) {
      sscanf(g_tpmax,"%ld",&itpm);
      *t_lim = (DOUBLE)itpm;
   }
   else {
//</new>
//</modif>
//<modif>
//<old>
/*
#ifdef _USE_RLIMIT
      getrlimit(RLIMIT_CPU,&rlp);
      *t_lim = (DOUBLE)rlp.rlim_max;
#else
      *t_lim = tmax;
#endif
*/
//<new>
#if defined _IGNORE_RLIMIT
	      *t_lim = tmax;
#else
#ifdef _USE_RLIMIT
      getrlimit(RLIMIT_CPU,&rlp);
      *t_lim = (DOUBLE)rlp.rlim_max;
#else
      *t_lim = tmax;
#endif
#endif
//</new>
//</modif>
   }
   if (*t_lim > tmax) {
      *t_lim = tmax;
   }
}
